#include <StringView.h>
#include <Slider.h>
#include <stdlib.h>
#include "BeBubbles.h"

// MAIN INSTANTIATION FUNCTION
extern "C" _EXPORT BScreenSaver *instantiate_screen_saver(BMessage *message, image_id image)
{
	return new BeBubbles(message, image);
}

BeBubbles::BeBubbles(BMessage *message, image_id image)
 : BScreenSaver(message, image)
{
}

//********************************************************
//	The BView shown in the screensaver-preference window
//********************************************************
void BeBubbles::StartConfig(BView *view)
{	
	BView *tView;
	nBubbles = 400;			// number of bubbles shown on screen
	
	view->AddChild(tView=new BStringView(BRect(8, 0, 200, 30), B_EMPTY_STRING, "BeBubbles"));
	tView->SetFontSize(28);
	view->AddChild(new BStringView(BRect(10, 35, 200, 45), B_EMPTY_STRING, "(c) 2000 XLR8 Design"));
	view->AddChild(new BStringView(BRect(10, 47, 200, 57), B_EMPTY_STRING, "  by Frans van Nispen"));
	}


//********************************************************
//	initialize screensaver
//********************************************************
status_t BeBubbles::StartSaver(BView *view, bool preview)
{
  	BRect	r=view->Bounds();

	if	(preview)	nBubbles=40;
	else			nBubbles=400;

	for(int i=1;i<maxBubbles;i++){

		myBubble[i]	=	bubble();
		
		myBubble[i].mx=	(int)r.right/2;
		myBubble[i].my=	(int)r.bottom/2;
		myBubble[i].x	=	rand() % (int)r.right - myBubble[i].mx;
		myBubble[i].y	=	rand() % (int)r.bottom - myBubble[i].my;
		myBubble[i].preview=preview;
		
	}
	

	SetTickSize(20000);
	return B_OK;
}


//********************************************************
//	update the bubble-movement
//********************************************************
void	bubble::draw(BView *view){

		int	xx = x*z/1000;
		int yy = y*z/1000;
		int	ra = rad*z/1000;
		
		BPoint	p;
		
		view->SetHighColor(0,0,0);
		
		p.x = xx+mx;
		p.y = yy+my;
		view->StrokeEllipse(p,rad,rad);
		
		z+=frac;
		xx = x*z/1000;
		yy = y*z/1000;
		ra = rad*z/1000;
		
		if ((xx<-(mx+rad))|(yy<-(my+rad))|(xx>(mx+rad))|(yy>(my+rad)))
			{ 	z = rand() % 1000;
	  			xx = x*z/1000;
				yy = y*z/1000;
				ra = rad*z/1000;
			}
				
		view->SetHighColor(red,green,blue);
		
		p.x = xx+mx;
		p.y = yy+my;
		view->StrokeEllipse(p,rad,rad);
}


//********************************************************
//	draw all bubbles to the screen
//********************************************************
void BeBubbles::Draw(BView *view, int32 frame)
{
	if (frame==0) { view->SetHighColor(0,0,0);
				view->FillRect(view->Bounds());
			}
	
	for(int i=1;i<nBubbles;i++)
	{
		myBubble[i].draw(view);

	}
}
